Subject: Re: .gitignore and git stash -u

From: Junio C Hamano <[email-masked]>
Date: Tue, 22 Jul 2014 14:22:29 -0700

Jeffry Johnston <[email-masked]> writes:

> We had been experiencing "random" deletions of files and directories,
> and we finally figured out what they were: git stash -u.  A coworker
> happened upon a webpage (after losing a weeks worth of experimental
> work, back to his last backup), which described our problems exactly:
>
> http://blog.icefusion.co.uk/git-stash-can-delete-ignored-files-git-stash-u/
>
> The command git stash -u deletes ignored files from the hard drive..
> very dangerous!

Although I never use "stash --include-untracked" myself, I think it
is deliberate that the command removes all the untracked files.  The
author of that "feature" explains its use this way:

commit 787513027a7d0af3c2cd2f04b85bc7136d580586
Author: David Caldwell <[email-masked]>
Date:   Fri Jun 24 17:56:06 2011 -0700

    stash: Add --include-untracked option to stash and remove all untracked files
    
    The --include-untracked option acts like the normal "git stash save" but
    also adds all untracked files in the working directory to the stash and then
    calls "git clean --force --quiet" to restore the working directory to a
    pristine state.
    
    This is useful for projects that need to run release scripts. With this
    option, the release scripts can be from the main working directory so one
    does not have to maintain a "clean" directory in parallel just for
    releasing. Basically the work-flow becomes:
    
       $ git tag release-1.0
       $ git stash --include-untracked
       $ make release
       $ git clean -f
       $ git stash pop
    
    "git stash" alone is not enough in this case--it leaves untracked files
    lying around that might mess up a release process that expects everything to
    be very clean or might let a release succeed that should actually fail (due
    to a new source file being created that hasn't been committed yet).
    
    Signed-off-by: David Caldwell <[email-masked]>
    Signed-off-by: Junio C Hamano <[email-masked]>